/*
 * 16F88_Ref3_Timer0
 * Timer0荞݂gLED_łvO
 * 
 * File:   main.c
 * Author: Taichi
 *
 * Created on 2017/02/22, 12:57
 */

// CONFIG1
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTRC oscillator; port I/O function on both RA6/OSC2/CLKO pin and RA7/OSC1/CLKI pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off)
#pragma config CCPMX = RB3      // CCP1 Pin Selection bit (CCP1 function on RB3)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)

// CONFIG2
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)

#define LED1 RA0 // True ON LED
#define LED2 RA6 // False ON LED
#define SWITCH1 RA1 // Pull Down Switch
#define SWITCH2 RA7 // Pull Up Switch
#define VOLUME RA4 // VR1
#define SENSOR RB4 // Photo Sensor
#define M_IN1 RA2 // H-bridge IN1
#define M_IN2 RA3 // H-bridge IN2
#define TR RB3 // Transistor

#define _XTAL_FREQ 8000000      // 8MHz

#define RTCC_INTERNAL 0x00      // pX͓NbNg
#define RTCC_DIV_256 0x07       // vXP[̐ݒl: 256 (0b111)
#define TMR0_DATA 0x00          // TMR0̏l
#define CNT_DATA 30             // 1bJE^pϐ̏livZ͉Lj
// 1sec / ((1/NbN) * 4 * vXP[ݒl * (255 - (TMR0l - 1)))
// 1/(1/8000000*4*256*(255-(0-1)))=30.5175  :1sec/1JEgɂ鎞

#include <xc.h>
#include <stdio.h>
#include "uart.h"

unsigned char cnt; // 荞݊֐ŎgpJEgϐ

// vg^Cv錾
void initTMR0(unsigned char mode);
void setTMR0(unsigned char tmr0);
void interrupt isrTMR0();

void main(void) {
    
    OSCCON = 0b01110000;    // NbN̎g8MHzɐݒ
 
    PORTA = 0x00;           // PORTA
    PORTB = 0x00;           // PORTB
    TRISA = 0b10010010;     // PORTA̓o͐ݒ RA1,7SWITCH, RA4VOLUME
    TRISB = 0b00010100;     // PORTB̓o͐ݒ RB2RX, RB4SENSOR
    ANSEL = 0b00000000;     // ADRo[^
    
    initUART();             // VAʐMݒ
    __delay_ms(100);
    
    cnt = CNT_DATA;             // TMR0݂𗘗p1bJE^pϐ
     
    initTMR0(RTCC_INTERNAL | RTCC_DIV_256);
    setTMR0(TMR0_DATA);         // TMR0̏lݒ
 
    TMR0IE = 1;                   // TMR0݂
    GIE = 1;                    // O[o݂
     
    while(1){                   // [v
    }
}


void initTMR0(unsigned char mode)
{
    OPTION_REG &= 0b11000000; // rbg}XN
    OPTION_REG |= mode; // pX͓orOAvXP[lݒ
    TMR0 = 0x00; // TMR0̃JEgl0ɂ
}
 
void setTMR0(unsigned char tmr0)
{
    TMR0 = tmr0; // TMR0̏lݒ
}
 
void interrupt isrTMR0() // ISR:Interrupt Service Routine 
{
    TMR0IF = 0;       // TMR0݂NA
    cnt--;
    if(cnt == 0){
        cnt = CNT_DATA;         // 1bJE^pϐ
        PORTA ^= 0b01000001;    // RA0(LED1)RA6(LED2)rbg]
        printf("hello world\n");
    }
}
